> For the complete documentation index, see [llms.txt](https://integrations.impact.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://integrations.impact.com/brand-api-reference/advocate-api-reference-v1/reference/referral-overview/models.md).

# Models

## The ReferralList object

```json
{"openapi":"3.1.0","info":{"title":"SaaSquatch by impact.com API - Referral","version":"1.0.0"},"components":{"schemas":{"ReferralList":{"type":"object","properties":{"count":{"type":"integer"},"totalCount":{"type":"integer"},"referrals":{"type":"array","items":{"$ref":"#/components/schemas/Referral"}}}},"Referral":{"description":"A link between the user/account of the referrer and the new referred user/account.","properties":{"id":{"type":"string"},"referredUser":{"$ref":"#/components/schemas/User"},"referrerUser":{"$ref":"#/components/schemas/User"},"referredReward":{"$ref":"#/components/schemas/Reward"},"referrerReward":{"nullable":true,"allOf":[{"$ref":"#/components/schemas/Reward"}]},"referralCodeUsed":{"type":"string","nullable":true},"shareLinkUsed":{"type":"string","nullable":true},"moderationStatus":{"type":"string","enum":["PENDING","ACTIONED"]},"referredModerationStatus":{"type":"string","enum":["PENDING","APPROVED","DENIED"]},"referrerModerationStatus":{"type":"string","enum":["PENDING","APPROVED","DENIED"]},"fraudSignals":{"nullable":true,"allOf":[{"$ref":"#/components/schemas/FraudSignals"}]},"dateReferralStarted":{"type":"integer","format":"int64"},"dateReferralPaid":{"type":"integer","format":"int64","nullable":true},"dateReferralEnded":{"type":"integer","format":"int64","nullable":true},"dateModerated":{"type":"integer","format":"int64","nullable":true},"dateConverted":{"type":"integer","format":"int64","nullable":true,"description":"Unix timestamp (milliseconds) when the referral converted."},"dateModified":{"type":"integer","format":"int64","description":"Unix timestamp (milliseconds) when the referral was last modified."},"dateUserModified":{"type":"integer","format":"int64","nullable":true,"description":"Unix timestamp (milliseconds) when the referred user was last modified."},"programId":{"type":"string","nullable":true,"description":"The ID of the program this referral belongs to."}}},"User":{"type":"object","properties":{"id":{"type":"string"},"accountId":{"type":"string"},"firstName":{"type":"string"},"lastName":{"type":"string"},"lastInitial":{"type":"string"},"email":{"type":"string","format":"email"},"emailHash":{"type":"string","description":"An MD5 hash of the user's email address."},"imageUrl":{"type":"string","description":"URL of the user's profile image. Empty string if not set."},"referralCode":{"type":"string"},"cookieId":{"type":"string","nullable":true},"paymentProviderId":{"type":"string","nullable":true},"locale":{"type":"string","nullable":true},"countryCode":{"type":"string","nullable":true},"referralSource":{"type":"string","nullable":true},"firstSeenIP":{"type":"string","nullable":true},"lastSeenIP":{"type":"string","nullable":true},"dateCreated":{"type":"integer","format":"int64"},"dateBlocked":{"type":"integer","format":"int64","nullable":true},"shareLinks":{"type":"object","description":"The user's share links, organised by share medium and engagement medium."}}},"Reward":{"type":"object","properties":{"id":{"type":"string"},"type":{"type":"string"},"uniqueId":{"type":"string","nullable":true},"dateCreated":{"type":"integer","format":"int64"},"dateScheduledFor":{"type":"integer","format":"int64","nullable":true},"dateGiven":{"type":"integer","format":"int64","nullable":true},"dateExpires":{"type":"integer","format":"int64","nullable":true},"dateCancelled":{"type":"integer","format":"int64","nullable":true},"accountId":{"type":"string"},"userId":{"type":"string"},"cancellable":{"type":"boolean"},"rewardSource":{"type":"string"},"programId":{"type":"string","nullable":true},"programRewardKey":{"type":"string","nullable":true},"globalRewardKey":{"type":"string","nullable":true},"referralId":{"type":"string","nullable":true},"unit":{"type":"string"},"assignedCredit":{"type":"integer"},"redeemedCredit":{"type":"integer"},"name":{"type":"string"},"currency":{"type":"string","nullable":true},"redemptions":{"type":"object","nullable":true}}},"FraudSignals":{"type":"object","properties":{"name":{"$ref":"#/components/schemas/FraudSignal"},"ip":{"$ref":"#/components/schemas/FraudSignal"},"email":{"$ref":"#/components/schemas/FraudSignal"},"rate":{"$ref":"#/components/schemas/FraudSignal"}}},"FraudSignal":{"type":"object","properties":{"message":{"type":"string"},"score":{"type":"integer"}}}}}}
```

## The Referral object

```json
{"openapi":"3.1.0","info":{"title":"SaaSquatch by impact.com API - Referral","version":"1.0.0"},"components":{"schemas":{"Referral":{"description":"A link between the user/account of the referrer and the new referred user/account.","properties":{"id":{"type":"string"},"referredUser":{"$ref":"#/components/schemas/User"},"referrerUser":{"$ref":"#/components/schemas/User"},"referredReward":{"$ref":"#/components/schemas/Reward"},"referrerReward":{"nullable":true,"allOf":[{"$ref":"#/components/schemas/Reward"}]},"referralCodeUsed":{"type":"string","nullable":true},"shareLinkUsed":{"type":"string","nullable":true},"moderationStatus":{"type":"string","enum":["PENDING","ACTIONED"]},"referredModerationStatus":{"type":"string","enum":["PENDING","APPROVED","DENIED"]},"referrerModerationStatus":{"type":"string","enum":["PENDING","APPROVED","DENIED"]},"fraudSignals":{"nullable":true,"allOf":[{"$ref":"#/components/schemas/FraudSignals"}]},"dateReferralStarted":{"type":"integer","format":"int64"},"dateReferralPaid":{"type":"integer","format":"int64","nullable":true},"dateReferralEnded":{"type":"integer","format":"int64","nullable":true},"dateModerated":{"type":"integer","format":"int64","nullable":true},"dateConverted":{"type":"integer","format":"int64","nullable":true,"description":"Unix timestamp (milliseconds) when the referral converted."},"dateModified":{"type":"integer","format":"int64","description":"Unix timestamp (milliseconds) when the referral was last modified."},"dateUserModified":{"type":"integer","format":"int64","nullable":true,"description":"Unix timestamp (milliseconds) when the referred user was last modified."},"programId":{"type":"string","nullable":true,"description":"The ID of the program this referral belongs to."}}},"User":{"type":"object","properties":{"id":{"type":"string"},"accountId":{"type":"string"},"firstName":{"type":"string"},"lastName":{"type":"string"},"lastInitial":{"type":"string"},"email":{"type":"string","format":"email"},"emailHash":{"type":"string","description":"An MD5 hash of the user's email address."},"imageUrl":{"type":"string","description":"URL of the user's profile image. Empty string if not set."},"referralCode":{"type":"string"},"cookieId":{"type":"string","nullable":true},"paymentProviderId":{"type":"string","nullable":true},"locale":{"type":"string","nullable":true},"countryCode":{"type":"string","nullable":true},"referralSource":{"type":"string","nullable":true},"firstSeenIP":{"type":"string","nullable":true},"lastSeenIP":{"type":"string","nullable":true},"dateCreated":{"type":"integer","format":"int64"},"dateBlocked":{"type":"integer","format":"int64","nullable":true},"shareLinks":{"type":"object","description":"The user's share links, organised by share medium and engagement medium."}}},"Reward":{"type":"object","properties":{"id":{"type":"string"},"type":{"type":"string"},"uniqueId":{"type":"string","nullable":true},"dateCreated":{"type":"integer","format":"int64"},"dateScheduledFor":{"type":"integer","format":"int64","nullable":true},"dateGiven":{"type":"integer","format":"int64","nullable":true},"dateExpires":{"type":"integer","format":"int64","nullable":true},"dateCancelled":{"type":"integer","format":"int64","nullable":true},"accountId":{"type":"string"},"userId":{"type":"string"},"cancellable":{"type":"boolean"},"rewardSource":{"type":"string"},"programId":{"type":"string","nullable":true},"programRewardKey":{"type":"string","nullable":true},"globalRewardKey":{"type":"string","nullable":true},"referralId":{"type":"string","nullable":true},"unit":{"type":"string"},"assignedCredit":{"type":"integer"},"redeemedCredit":{"type":"integer"},"name":{"type":"string"},"currency":{"type":"string","nullable":true},"redemptions":{"type":"object","nullable":true}}},"FraudSignals":{"type":"object","properties":{"name":{"$ref":"#/components/schemas/FraudSignal"},"ip":{"$ref":"#/components/schemas/FraudSignal"},"email":{"$ref":"#/components/schemas/FraudSignal"},"rate":{"$ref":"#/components/schemas/FraudSignal"}}},"FraudSignal":{"type":"object","properties":{"message":{"type":"string"},"score":{"type":"integer"}}}}}}
```

## The ReferralModerationBulkRequest object

```json
{"openapi":"3.1.0","info":{"title":"SaaSquatch by impact.com API - Referral","version":"1.0.0"},"components":{"schemas":{"ReferralModerationBulkRequest":{"description":"A request to perform one or several moderation actions.","required":["actions"],"properties":{"actions":{"type":"array","minItems":1,"maxItems":100,"items":{"$ref":"#/components/schemas/ReferralModerationRequest"}}}},"ReferralModerationRequest":{"description":"A request to moderate a single referral.","required":["referralId","action"],"properties":{"referralId":{"type":"string"},"action":{"type":"string","enum":["APPROVED","DENIED","REFERRER_APPROVED","REFERRED_APPROVED","REFERRER_DENIED","REFERRED_DENIED"]}}}}}}
```

## The ReferralModerationRequest object

```json
{"openapi":"3.1.0","info":{"title":"SaaSquatch by impact.com API - Referral","version":"1.0.0"},"components":{"schemas":{"ReferralModerationRequest":{"description":"A request to moderate a single referral.","required":["referralId","action"],"properties":{"referralId":{"type":"string"},"action":{"type":"string","enum":["APPROVED","DENIED","REFERRER_APPROVED","REFERRED_APPROVED","REFERRER_DENIED","REFERRED_DENIED"]}}}}}}
```

## The User object

```json
{"openapi":"3.1.0","info":{"title":"SaaSquatch by impact.com API - Referral","version":"1.0.0"},"components":{"schemas":{"User":{"type":"object","properties":{"id":{"type":"string"},"accountId":{"type":"string"},"firstName":{"type":"string"},"lastName":{"type":"string"},"lastInitial":{"type":"string"},"email":{"type":"string","format":"email"},"emailHash":{"type":"string","description":"An MD5 hash of the user's email address."},"imageUrl":{"type":"string","description":"URL of the user's profile image. Empty string if not set."},"referralCode":{"type":"string"},"cookieId":{"type":"string","nullable":true},"paymentProviderId":{"type":"string","nullable":true},"locale":{"type":"string","nullable":true},"countryCode":{"type":"string","nullable":true},"referralSource":{"type":"string","nullable":true},"firstSeenIP":{"type":"string","nullable":true},"lastSeenIP":{"type":"string","nullable":true},"dateCreated":{"type":"integer","format":"int64"},"dateBlocked":{"type":"integer","format":"int64","nullable":true},"shareLinks":{"type":"object","description":"The user's share links, organised by share medium and engagement medium."}}}}}}
```

## The Reward object

```json
{"openapi":"3.1.0","info":{"title":"SaaSquatch by impact.com API - Referral","version":"1.0.0"},"components":{"schemas":{"Reward":{"type":"object","properties":{"id":{"type":"string"},"type":{"type":"string"},"uniqueId":{"type":"string","nullable":true},"dateCreated":{"type":"integer","format":"int64"},"dateScheduledFor":{"type":"integer","format":"int64","nullable":true},"dateGiven":{"type":"integer","format":"int64","nullable":true},"dateExpires":{"type":"integer","format":"int64","nullable":true},"dateCancelled":{"type":"integer","format":"int64","nullable":true},"accountId":{"type":"string"},"userId":{"type":"string"},"cancellable":{"type":"boolean"},"rewardSource":{"type":"string"},"programId":{"type":"string","nullable":true},"programRewardKey":{"type":"string","nullable":true},"globalRewardKey":{"type":"string","nullable":true},"referralId":{"type":"string","nullable":true},"unit":{"type":"string"},"assignedCredit":{"type":"integer"},"redeemedCredit":{"type":"integer"},"name":{"type":"string"},"currency":{"type":"string","nullable":true},"redemptions":{"type":"object","nullable":true}}}}}}
```

## The FraudSignals object

```json
{"openapi":"3.1.0","info":{"title":"SaaSquatch by impact.com API - Referral","version":"1.0.0"},"components":{"schemas":{"FraudSignals":{"type":"object","properties":{"name":{"$ref":"#/components/schemas/FraudSignal"},"ip":{"$ref":"#/components/schemas/FraudSignal"},"email":{"$ref":"#/components/schemas/FraudSignal"},"rate":{"$ref":"#/components/schemas/FraudSignal"}}},"FraudSignal":{"type":"object","properties":{"message":{"type":"string"},"score":{"type":"integer"}}}}}}
```

## The FraudSignal object

```json
{"openapi":"3.1.0","info":{"title":"SaaSquatch by impact.com API - Referral","version":"1.0.0"},"components":{"schemas":{"FraudSignal":{"type":"object","properties":{"message":{"type":"string"},"score":{"type":"integer"}}}}}}
```

## The Error object

```json
{"openapi":"3.1.0","info":{"title":"SaaSquatch by impact.com API - Referral","version":"1.0.0"},"components":{"schemas":{"Error":{"properties":{"statusCode":{"type":"integer","format":"int32"},"message":{"type":"string","description":"The human-readable description of what went wrong. Use this to help you debug."},"apiErrorCode":{"type":"string","description":"A machine-readable error code."},"rsCode":{"type":"string","nullable":true,"description":"A secondary machine-readable error code."}}}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://integrations.impact.com/brand-api-reference/advocate-api-reference-v1/reference/referral-overview/models.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
